require "util"
require "defines"

script.on_init(function() On_Load() end)
script.on_load(function() On_Load() end)
script.on_event(defines.events.on_tick, function() On_Tick() end)

script.on_event(defines.events.on_built_entity, function(event) On_Built(event) end)
script.on_event(defines.events.on_robot_built_entity, function(event) On_Built(event) end)

script.on_event(defines.events.on_preplayer_mined_item, function(event) On_Removed(event) end)
script.on_event(defines.events.on_robot_pre_mined, function(event) On_Removed(event) end)
script.on_event(defines.events.on_entity_died, function(event) On_Removed(event) end)

remote.add_interface("PneumaticTransport",
{
  connect = function()
	game.players[1].print("It works!")
  end
}
)

--Ticker, cause i don't want all to be called all the time!
tickerA = 240
tickerB = 0

function On_Load()
	if not global.networks then
		global.networks = {}
	end
	if not global.distance then
		global.distance = {}
	end
	if not global.movingitems then
		global.movingitems = {}
	end
	if not global.movingcapsules then
		global.movingcapsules = {}
		if #global.networks >= 1 then
		  capsulesMoved = {}
		  for d = 1, #global.networks do
		    global.movingcapsules[#global.movingcapsules+1] = capsulesMoved
			game.players[1].print("Added movingCapsules: "..d)
		  end
		end
	end
	if not global.payed then
		global.payed = {}
		if #global.networks >= 1 then
		  networkPayed = 0
		  for d = 1, #global.networks do
		    global.payed[#global.payed+1] = networkPayed
			game.players[1].print("Added networkPayed: "..d)
		  end
		end
	end
end

function On_Tick()
    if tickerA == 0 then
	  emptyFromMove()
	  returnCapsules()
	  findRequests()  
      tickerA = 240
	else
	  tickerA = tickerA - 1
	end
    if conStarted ~= 0 then
	  networkCreation()
	end
end

function On_Built(event)
	local ent = event.created_entity
	if ent.name == "connector" then
	  for i,player in ipairs(game.players) do
	    game.players[i].insert({name = "connector", count = 1})
        game.players[i].print("Connector was put back into inventory")
	  end
	  connect(ent)
	  ent.destroy()
	  
	
	end
end

function On_Removed(event)
	local ent = event.entity
	if ent.name == "pSupply" then
		for i = 1, #global.networks do 
		  pSupply = global.networks[i][1]
			if pSupply == ent then
			  game.players[1].print("Removed supply"..#global.networks)
			  table.remove(global.networks, i)
			  table.remove(global.movingitems, i)
			  table.remove(global.distance, i)
			  return
			end
		end
	end
	if ent.name == "pRequest" then 
		for i = 1, #global.networks do 
		  pRequest = global.networks[i][2]
			if pRequest == ent then
			  table.remove(global.networks, i)
			  table.remove(global.movingitems, i)
			  table.remove(global.distance, i)
			  game.players[1].print("Removed requester"..#global.networks)
			  resetReqSlots()
			  return
			end
		end
	end
	if ent.name == "logistic-chest-requester" then
	  resetReqSlots()
	end
end

function connect(ent)
  --ent.destroyed
 -- game.players[1].insert({name = "connector", count = 1})
  game.players[1].print("Connection started. Please hover over a Pneumatic Supplier. PS This will ONLY work for player 1 in multiplayer or singleplayer!!")
  conStarted = 1
  timeLeft = 7200
end

function networkCreation()
	if conStarted == 1 then
	--game.players[1].print("ITS GOING")
	  if timeLeft > 0 and timeLeft < 7190 then 
	  --Checking if it's really an entity that is selected(Caused lots of pain to fix :O!
		if game.players[1].selected ~= nil then 
		 sele = game.players[1].selected.name	
	     if sele == "pSupply" then
		 --Setting nodes = 2 at start for ease since spot 1 in table is for the supply chest and spot 2 for the requesting chest
		   nodes = 2
		   game.players[1].print("Great supply chest connected, please find a node/Pneumatic requester to connect to")
		   --Counting number of pNetworks in game.
		   networkNr = 0
		   for numb, info in pairs(global.networks) do
		     networkNr = networkNr + 1
		   end
		   networkNr = networkNr + 1
		   networkx = {}
		   --global.networks[networkNr] = networkx
		   game.players[1].print("Inserting Supplier int network Numbr: "..networkNr)
		   networkx[1] = game.players[1].selected
		   --Begininning selection of node
		   timeLeft = 7200
		   conStarted = 2
		 end
		end
	  end
	  timeLeft = timeLeft - 1
	  --Supply connected now to connect nodes 
	elseif conStarted == 2 then
	 if timeLeft > 0 and timeLeft < 7150 then 
	  --Checking if it's really an entity that is selected(Caused lots of pain to fix :O!
		if game.players[1].selected ~= nil then 
		 sele = game.players[1].selected.name
         pos = game.players[1].selected.position		 
	     if sele == "pNode" then
		   nodes = nodes + 1
		   game.players[1].print("Great pNode connected, please find a node/Pneumatic requester to connect to")
		   --table.insert(global.networks[networkNr], pos)
		   networkx[nodes] = pos
		   timeLeft = 7200
		   conStarted = 2
		 elseif sele == "pRequest" then
		    --Putting the request chest at the second position	
		   game.players[1].print("Inserting requester"..networkNr)
		   game.players[1].print("Great! pRequester connected. Network stuff done :)! ")  
		   networkx[2] = game.players[1].selected
		   global.networks[#global.networks+1] = networkx
		   --Create a table containing all items in pipe
		   networkMoved = {}
		   capsulesMoved = {}
		   global.movingitems[#global.movingitems+1] = networkMoved
		   global.movingcapsules[#global.movingcapsules+1] = capsulesMoved
		   global.payed[#global.payed] = 0
		   tickerB = 0
		   --Little bit cheaty but thats how i got to do it :/ Atleast checking if dist is negative as i want positive numbers!
		   distx = global.networks[#global.movingitems][1].position.x - global.networks[#global.networks][2].position.x
		   if distx < 0 then
		     distx = distx - distx - distx
		   end
		   disty = global.networks[#global.movingitems][1].position.y - global.networks[#global.networks][2].position.y
		   if disty < 0 then
		     disty = disty - disty - disty
		   end
		   totDist = disty + distx
		   --Dividing by 50 and rounding up to get the number of buffer slots, 1 every 50 + the first. 
		   totDist = totDist/50
		   totDist = math.ceil(totDist)
		   --Adding the number of bufferslots into the global.distance table
		   --game.players[1].print("MaxSlots: "..totDist)
		   global.distance[#global.distance+1] = totDist
		   --Resetting stuff for safety
		   conStarted = 0
		   timeLeft = 0
		   networkNr = 0
		   for numb, info in pairs(global.networks) do
		     networkNr = networkNr + 1
		   end
		   for i = 1, networkNr do 
		     --game.players[1].print("Nodes in network: "..i)
		     for k, v in pairs(global.networks[i]) do
			   if k > 2 then
		        -- game.players[1].print(v.x.." : "..v.y)
			   else
			     --game.players[1].print("Supply/request at: "..v.position.x.." : "..v.position.y)
			   end
		     end
		   end
		 end
		end
	  end
      timeLeft = timeLeft - 1	  
	end
end
--Check if the network is still working, meaning no node is missing.
function isValid()
  
end

--Find if there is a request of anything
radius = 20
function findRequests()
  for networkM = 1, #global.networks do
    if global.payed[networkM] == 1 then
    --game.players[1].print("NetworkNr: "..#global.networks)
    local requester = global.networks[networkM][2]
	local results = requester.surface.find_entities_filtered{area = {{requester.position.x-radius,requester.position.y-radius},{requester.position.x+radius,requester.position.y+radius}}, name = "logistic-chest-requester"}
       for numb, target in pairs(results) do
	     --game.players[1].print("Found requester at xpos: "..target.position.x.." Requesting: ")
		 for slots = 1, 4 do 
		   request = target.get_request_slot(slots)
		   if request ~= nil then
		     nameorcount = 0
		     for what, info in pairs(request) do
	           local stack = {name = itemname, count = count}
			   if what == "name" then
				name = info
			   elseif what == "count" then 
				countN = info
			   end
		     end
			 checkifNeeded(name, countN, target, requester, networkM)
		   end
		 end
	   end
  else
    pay(networkM)
  end
  end
end

function pay(networkM)
  distx = global.networks[networkM][1].position.x - global.networks[networkM][2].position.x
  if distx < 0 then
    distx = distx - distx - distx
  end
    disty = global.networks[networkM][1].position.y - global.networks[networkM][2].position.y
  if disty < 0 then
    disty = disty - disty - disty
  end
  totDist = disty + distx
  if tickerB == 0 then
    game.players[1].print("Due to realism network number: "..networkM.." has to be payed.")
    game.players[1].print("Please insert: "..totDist.." Reinforced Pipes into the pneumatic supply chest in that network.")
    tickerB = 3000
   end
  --Check in supplychest for the required items
  supplier = global.networks[networkM][1]
  inv = supplier.get_inventory(1)
  for itemname, count in pairs(inv.get_contents()) do
    if itemname == "reinforced-pipe" and count >= totDist then
	  local stack = {name = itemname, count = totDist}
	  inv.remove(stack)
	  game.players[1].print("Thanks for following the guidelines! You may now use your very own pneumatic system as much as you wish!")
	  global.payed[networkM] = 1
	else
	  if tickerB == 0 then
	    game.players[1].print("Please make sure to put the required items in the network's supply chest and put atleast: "..totDist.." of them.")
	    tickerB = 3000
	  else
	    tickerB = tickerB - 1
	  end
	end
  end
end

--REMEMBER TO PUT IF STATEMENTS SO ONLY 1 THING IS CHECKED, efficiency is the key!!!
--Check if there is none of the requested item in the requesting chest. 
function checkifNeeded(name, countN, target, requester, networkM)
  found = 0
  --game.players[1].print(name.." : "..count)
  --Check if the pRequester chest got it
  local inv = target.get_inventory(1)
  for itemname, count in pairs(inv.get_contents()) do
    if itemname == name then
	 -- game.players[1].print("Ok, it's fine, it already got: "..count.." Items left")
	  --Setting found = 1 because it found that there is items left so nothing needs to be moved.
	  found = count
	end
  end
  --Check if the requested item is in the pRequesting chest
  local inv = requester.get_inventory(1)
  for itemname, count in pairs(inv.get_contents()) do
    if itemname == name then
	 -- game.players[1].print("Ok, it's fine, it already got some left in the requesting chest: "..count.." Items left")
	  --Setting found = 1 because it found that there is items left so nothing needs to be moved.
	  found = found + count
	end
  end
  --Check if there is something in the pipeline (table containing the items)
  maxSlot = global.distance[networkM]
  for slot = 1, maxSlot do 
    if global.movingitems[networkM][slot] ~= nil then
    if name == global.movingitems[networkM][slot]["name"] then
      found = found + global.movingitems[networkM][slot]["count"]
    end
	end
  end
  --Calling the addToMove function if nothing was found in both the requesting chest and pRequesting chest
  if found < countN then
    need = countN - found
    addToMove(name, need, requester, networkM)
  end
end

--Adds the items to be moved in a table containing all items in the "pipe" Also countN = needed items at pSupply
--Moves items from the pSupply, but if there isnt enough then it will request the items.
function addToMove(name, need, requester, networkM)

   found = 0
   moveItems = 0
   canMove = 0
   maxSlot = global.distance[networkM]
   --Make sure the first slot in the table(ok its last in code table, but first in the pipe) is empty
   if global.movingitems[networkM][maxSlot] == nil then
     supplier = global.networks[networkM][1]
     local supplyInv = supplier.get_inventory(1)
   	 for itemname, count in pairs(supplyInv.get_contents()) do
	   if count < 2 and itemname == name and found == 0 then
	     stackC = {name = itemname, count = count}
	   elseif count >= 2 and itemname == name and found == 0 then
		  stackC = {name = itemname, count = 2}
		  count = 2
	   end
	   --game.players[1].print("Moving")
	   --Check if there is available pCapsules
       if itemname == "pCapsule" then
		 canMove = 1
		 cStack = {name = itemname, count = count}
	   end
	   --only move what it needs to move
	   if itemname == name and found == 0 then
		 --game.players[1].print(itemname.." : "..name)
		 moveItems = 1
		 found = 1
	   end
	   --Make sure that there is enough capsules to send something
	   if moveItems == 1 and canMove == 1 then 
		 if cStack["count"] < stackC["count"] then
	       stackC["count"] = cStack["count"]
	     end
	     supplyInv.remove(stackC)
	     supplyInv.remove({name = "pCapsule", count = stackC["count"]})
	     global.movingitems[networkM][maxSlot] = stackC
	     --Reset the slot that made it request the items(if there is)
	     for slot = 1, 10 do
	       --game.players[1].print("Checking slot: "..slot)
	       resultSlot = supplier.get_request_slot(slot)
	  	   if resultSlot ~= nil then
		     if resultSlot["name"] == name then
		       supplier.clear_request_slot(slot)		 
		     end
		   end	
	     end
		 break
		 end
	  end
  end
  --If requested item was not found in pRequester, then the pRequester requests from the logistic network the required items.
  if found == 0 then
  slotThere = 0
    for slot = 1, 10 do 
      slotInfo = supplier.get_request_slot(slot)
	  if slotInfo ~= nil then 
	    if slotInfo["name"] == name and slotThere == 0 then
	      slotThere = 1
        end
      elseif slotInfo == nil then
   	    --Set where last empty slot was found!
	    emptySlot = slot
	  end
	end
	   if slotThere == 0 then
	     supplier.set_request_slot({name = name, count = need}, emptySlot)
		 slotThere = 1
	   end
  end
end

--Insert from first position in table to chest. 
function emptyFromMove()
    --Checking both the requesting chest and supplying chest is still there
	for networky = 1, #global.networks do
      if global.networks[networky][1] ~= nil then
	  -- game.players[1].print("Moving from networkNr: "..networky)
	    requester = global.networks[networky][2]
	    local requestInv = requester.get_inventory(1)
        if global.movingitems[networky][1] ~= nil then
		   --Insert into requesting pRequester
		   requester.insert({name = global.movingitems[networky][1]["name"], count = global.movingitems[networky][1]["count"]})
		   --Add the capsules to the return table, before whilst i still know the count of the items sent!
		   global.movingcapsules[networky][global.distance[networky]] = global.movingitems[networky][1]["count"]
		   --Remove stack from table
		   table.remove(global.movingitems[networky], 1)   
	   	 else
		   global.movingitems[networky][1] = "bad"
		   table.remove(global.movingitems[networky], 1)
	     end
	  end
	end
end

--Returning the capsules to it's staring supplying chest from the table
function returnCapsules()
	for networky = 1, #global.networks do
      if global.networks[networky][1] ~= nil then
	  -- game.players[1].print("Moving from networkNr: "..networky)
	    supplier = global.networks[networky][1]
	    local supplierInv = supplier.get_inventory(1)
        if global.movingcapsules[networky][1] ~= nil then
		   --Insert into requesting pRequester
		   supplier.insert({name = "pCapsule", count = global.movingcapsules[networky][1]})
		   --Remove stack from table
		   table.remove(global.movingcapsules[networky], 1)
	   	 else
		   global.movingcapsules[networky][1] = "bad"
		   table.remove(global.movingcapsules[networky], 1)
	     end
	  end
	end
end

--Need to remember to check if the target requesting chest is still requesting because it could have been removed!
function resetReqSlots()
  for networky = 1, #global.networks do
    supplier = global.networks[networky][1]
	for slot = 1, 10 do
	  supplier.clear_request_slot(slot)
	end
  end
end

--game.players[1].selected.set_request_slot({name = "iron-plate", count = 5}, 2)










